import {
  MyBetaModalFormProps,
  MyButtons,
  MyModalFormProps,
  rulesHelper,
} from '@/common';
import { Selects } from '@/components/Select';
import { Apis } from '@/gen/Apis';
import { BetaSchemaForm } from '@ant-design/pro-components';
import { ButtonProps, Form, message } from 'antd';

export default function Create(
  props: { buttonProps?: ButtonProps } & MyBetaModalFormProps,
) {
  const [form] = Form.useForm();
  return (
    <BetaSchemaForm<ApiTypes.Grid.Grids.AddManager>
      {...MyModalFormProps.props}
      title={`设置楼栋管家`}
      wrapperCol={{ span: 24 }}
      width="500px"
      form={form}
      key={new Date().getTime()}
      trigger={<MyButtons.Edit title="管家" type="primary" />}
      request={() => Promise.resolve(props.item)}
      onOpenChange={(open: any) => {
        if (open && props.item) {
          // 获取详情数据
          Apis.Grid.Grids.Show({
            id: props?.item?.id,
          }).then((res) => {
            form.setFieldsValue({
              ...res.data,
            });
          });
        }
      }}
      onFinish={async (values: any) =>
        Apis.Grid.Grids.AddManager({
          ...values,
          id: props?.item?.id,
        })
          .then(() => {
            props.reload?.();
            message.success('成功');
            return true;
          })
          .catch(() => false)
      }
      columns={[
        Selects?.Employees({
          title: '设置楼栋管家',
          dataIndex: 'company_employees_id',
          colProps: { span: 24 },
          formItemProps: { ...rulesHelper.text },
          params: {
            name: props?.item?.company_employee?.name,
          },
          fieldProps: {
            showSearch: true,
          },
          required: true,
        }),
      ]}
    />
  );
}
